'''
Created on Aug 23, 2010

@author: Dummey
'''
import pyglet
import random

city_batch = pyglet.graphics.Batch()
background = pyglet.graphics.OrderedGroup(0)
background2 = pyglet.graphics.OrderedGroup(1)
foreground = pyglet.graphics.OrderedGroup(2)

NORTH = 270
WEST = 180
SOUTH = 90
EAST = 0

directions = [NORTH, WEST, SOUTH, EAST]

road_image = pyglet.image.load("data/road.png")
road_image.anchor_y = 6

intersection_image = pyglet.image.load("data/intersection.png")
intersection_image.anchor_y = intersection_image.height/2
intersection_image.anchor_x = intersection_image.width/2

state_image = pyglet.image.load("data/arrow.png")
state_image.anchor_y = state_image.height/2
state_image.anchor_x = state_image.width/2

building_images = [pyglet.image.load("data/building3.png"), pyglet.image.load("data/building2.png"), pyglet.image.load("data/building1.png")]
for image in building_images:
    image.width = 110
    image.height = 110
    image.anchor_y = image.height/2
    image.anchor_x = image.width/2

distance = 60
intersection_range = 1

class City():
    streets = None    
    
    def __init__(self):
        global city_batch
        city_batch = pyglet.graphics.Batch()
        self.background = pyglet.image.load("data/background.png")
        self.streets = []
        self.buildings = []
        x = 720
        y = 600
        
        #make the streets
        for i in range(0, x/(distance*2)):
            for j in range(0, y/(distance*2)):
                paths = []
                if i > 0:
                    paths.append(WEST)
                if i < (x/(distance*2)-1):
                    paths.append(EAST)
                if j > 0:
                    paths.append(SOUTH)
                if j < (y/(distance*2)-1):
                    paths.append(NORTH)
                    
                self.streets.append(Intersection(i*distance*2+90, j*distance*2+distance+35, paths=paths))
                
        #make the buildings
        for i in range(0, x/(distance*2)-1):
            for j in range(0, y/(distance*2)-1):
                building = pyglet.sprite.Sprite(random.choice(building_images), batch=city_batch, group=foreground)
                building.set_position(i*distance*2+90+distance, j*distance*2+distance+35+distance)
                building.rotation = random.choice(directions)
                self.buildings.append(building)
    
    def get_intersection(self, x, y, range=intersection_range):
        for street in self.streets:
            if street.intersects(x, y, range=range):
                return street
        return False
    
    def update(self):
        pass
    
    def on_draw(self):
        self.background.blit(0,0)
        city_batch.draw()

class Intersection():
    
    def __init__(self, x, y, paths):
        self.x = x
        self.y = y
        self.state = None
        self.intersection_image = pyglet.sprite.Sprite(intersection_image, batch=city_batch, group=background2)
        self.intersection_image.set_position(x, y)
        self.state_graphics = pyglet.sprite.Sprite(state_image, batch=city_batch, group=foreground)
        self.state_graphics.set_position(x, y)
        self.state_graphics.visible = False
        self.paths = paths
        self.path_graphics = []
        self.create_streets()
        
    def create_streets(self):
        for path in self.paths:
            road = pyglet.sprite.Sprite(road_image, batch=city_batch, group=background)
            road.set_position(self.x, self.y)
            road.rotation = path
            self.path_graphics.append(road)

    def intersects(self, x, y, range = intersection_range):
        if abs(self.x - x) < range and abs(self.y - y) < range:
            return True
        else:
            return False
            
    def set_state(self, state):
        if state in self.paths:
            self.state = state
            self.state_graphics.visible = True
            self.state_graphics.rotation = state
        
    def cancel_state(self):
        self.state = None
        self.state_graphics.visible = False
        
    def get_paths(self):
        if self.state is not None:
            return [self.state]
        else:
            return self.paths
        
        