import pyglet
import shared.util as util
from shared.scene import Scene

class Story(Scene):    
    next_state = None
    story_text = pyglet.text.Label('Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras vulputate, ligula ac vestibulum condimentum, odio justo ornare eros, non auctor sem turpis sed nisl. Quisque in magna et tortor cursus porta a vitae odio. Praesent sed tellus sapien. Ut et ligula at tellus vestibulum tincidunt a id ligula. Vestibulum luctus.',
                          font_name='Candara',
                          font_size=20,
                          x=100, y=550,
                          height = 500,
                          width = 600,
                          multiline = True,
                          anchor_x='left',
                          anchor_y='top')
    
    next = pyglet.text.Label('Next',
                          font_name='Segoe Script',
                          font_size=24,
                          x=600, y=50,
                          height = 50,
                          width = 100,
                          anchor_x='center',
                          anchor_y='center')
    
    skip = pyglet.text.Label('Skip',
                          font_name='Segoe Script',
                          font_size=24,
                          x=700, y=50,
                          height = 50,
                          width = 100,
                          anchor_x='center',
                          anchor_y='center')
    
    
    all_text = [story_text, next, skip]
    
    story_page = None
    background = None
    
    def __init__(self, level_data):
        self.level_data = level_data
        
        self.page = 0
        self.story_text.text = self.level_data.pages[self.page][0]
        self.background = self.level_data.pages[self.page][1]
        
    def on_mouse_motion(self, x, y, dx, dy):
        for label in self.all_text:
            if util.intersects_label(x, y, label):
                label.bold = True
            else:
                label.bold = False
            
    def on_mouse_press(self, x, y, button, modifiers):
        if util.intersects_label(x, y, self.next):
            try:
                self.page += 1 
                self.story_text.text = self.level_data.pages[self.page][0]
                self.background = self.level_data.pages[self.page][1]
            except:
                self.next_state = True
            
        if util.intersects_label(x, y, self.skip):    
            self.next_state = True
    
    def on_draw(self):
        for label in self.all_text:
            label.draw()
        if self.background:
            self.background.blit(0,0)
        
    def update(self):
        return self.next_state
        
    